/*

====C(program, [defaultdl])====

Parses the C program in ''program'', and makes its functions, variables, structs, defs and enums available 
as properties of ''this''. If a ''default_dl'' is given, functions will be assumed to be defined there by default.

*/

C=function(code, default_dl) {
	C.populate.call(this,C.text_code(C.parse_code(C.ctoxml(C.cpp(code))),default_dl));
}

/*

====js_wrapper(program, [defaultdl])====

Parses the C program in ''program'', and returns a string containing a
js program which makes its functions, variables, structs,
defs and enums avaliable as properties of ''this''.

*/

C.js_wrapper=function(code,default_dl) {
	var text_code=C.text_code(C.parse_code(C.ctoxml(C.cpp(code))),default_dl);
	return 'C.populate.call(this,'+text_code.toSource()+');\n';
}

/*

====C_wrapper(String program, [defaultdl])====

Parses the C program in ''program'', and returns a string containing a
C program which makes its functions, variables, structs,
defs and enums avaliable as properties of ''this''.

*/

C.C_wrapper=function(code,default_dl) {
	return C.C_wrapper_i(C.parse_code(C.ctoxml(C.cpp(code))),default_dl);
}


