/*

====text_code(parsed_code)====

Returns text representations of parsed_code

*/

C.text_code=function(parsed_code,default_dl) {
	var ret={
		defs:{},
		struct:{},
		ptrs:{},
		dls:{},
		typedefs:{},
		structalias:{}
	};

	for (var name in parsed_code.enums) {
		var obj=parsed_code.enums[name];
		var defs=parsed_code.enumvals(obj);
		for (var i in defs) {
			ret.defs[i]=defs[i];
		}
	}

	for (var name in parsed_code.defs) {
		var obj=parsed_code.defs[name];
		ret.defs[name]=parsed_code.macro(obj);
	}

	for (var name in parsed_code.structs) {
		var obj=parsed_code.structs[name];
		ret.struct[name]=parsed_code.structstring(obj);
	}

	parsed_code.loaddls(default_dl);

	for (var index in parsed_code.ptrs) {
		var obj=parsed_code.ptrs[index];
		var dlindex=parsed_code.link(parsed_code.type(obj).ident);
		if (dlindex!=undefined)
			ret.ptrs[index]=[parsed_code.typestring(obj), dlindex];
	}

	for (var name in parsed_code.typedefs) {
		var obj=parsed_code.typedefs[name];
		var type=parsed_code.type(obj);
		if (type.dim.length==0 && type.type=="struct")
			ret.structalias[name]=type.struct_id;
		else
			ret.typedefs[name]=parsed_code.typestring(obj);
	}

	ret.dls=parsed_code.dls;
    if (default_dl!=undefined) ret.default_dl=default_dl.filename;

	return ret;
}


/*

====populate(text_code)====

Populates ''this'' with contents of text_code.

*/

C.populate=function(text_code) {
    if (this.struct==undefined) this.struct={};
	for (var name in text_code.struct) {
		this.struct[name]=new Type(" 0 "+text_code.struct[name]);
	}

	for (var name in text_code.typedefs) {
		this[name]=new Type(text_code.typedefs[name]);
	}

	for (var name in text_code.structalias) {
		this[name]=this.struct[text_code.structalias[name]];
	}

	var dls=[];
	for (var index in text_code.dls) {
		if (typeof(text_code.dls[index])=="string")
			dls[index]=dl(text_code.dls[index]);  // load dl
		else if (text_code.dls[index]==0)
			dls[index]=null; // main
	}
	if (text_code.default_dl!=undefined)
		dls[0]=dl(text_code.default_dl); // default

	for (var index in text_code.ptrs) {
		var typestring=text_code.ptrs[index][0];
		var ptr=new Pointer(typestring, dls[text_code.ptrs[index][1]]);
		ptr.struct=this.struct;
		var match;
		if (match=typestring.match(/^([^ ]*) 0 F/))
			this[match[1]]=funcwrapper(ptr);
		else
			this[match[1]]=ptr;
	}

	_resolve_disable=true;
	for (var name in text_code.defs) {
		try {
			with (this) {
				this[name]=eval(text_code.defs[name]);
			}
		} catch(x) {
			
		} finally {
			_resolve_disable=true;
		}
	}

	function funcwrapper(ptr) {
		return function() {
			return ptr.apply(arguments);
		}
	}
}

