/*
===Bool _resolve(String name, Bool writing)===

This method is to be used as a property of a [[Magic]] class. Any attempt to access an undefined property of the object will cause
the _resolve function to be called. This function, in turn, will call [[include]], which attempts to load a file which will resolve
the property. That would be either ''name''.js or ''name'', which is assumed to be a directory if it exists.

*/

AnyName=undefined;
PropertyIterator=null;
_resolve_disable=false;

function _resolve(name, writing) {
	if (writing || name==undefined) return true;
	if (this._resolve_disable) return false;
	var ret=false;

	try {
		var ret=module.include(name, true);
	} catch (err) {
		module.include('alert');
		alert("Line ",err.lineNumber," in ",err.fileName," while resolving ",name,": ",err,"\n");
		return ret;
	}

	return ret;
}

