gmp={};

gmp.z=function (value, base) {
	var ret=_.New(_.mpz_t);
	if (value===undefined) {
		_.mpz_init(ret);
		return ret;
	}

	if (base==undefined) base=0;

	switch(typeof(value)) {
	case "string":
		var res=_.mpz_init_set_str(ret, value, base);
		if (res==-1) {
			gmp.z.clear(ret);
			throw("gmp.z");
		}
		break;
	case "number":
		_.mpz_init_set_d(ret, value);
		break;
	case "object": // assume it's a gmp.z
		_.mpz_init_set(ret, value);
		break;
	}
	return ret;
}

gmp.z.get_str=function(op, base) {
	if (base==undefined) {
		base=10;
	}
	var ret=_.mpz_get_str(null, base, op);
	var ret2=ret.string();
	_.free(ret);
	return ret2;
}

gmp.q=function (op1, op2) {
	var ret=_.New(_.mpq_t);
	_.mpq_init(ret);

	if (op1===undefined) {
		return ret;
	}

	if (op2==undefined)
		op2=0;

	switch(typeof(op1)) {
	case "string":
		var res=_.mpq_set_str(ret, op1, op2);
		if (res==-1) {
			gmp.q.clear(ret);
			throw("gmp.q");
		}
		break;
	case "number":
		_.mpq_set_si(ret, op1, op2);
		break;
	case "object": // assume it's a gmp.q
		_.mpq_set(ret, op1);
		break;
	}
	return ret;
}

gmp.q.get_str=function(op, base) {
	if (base==undefined) {
		base=10;
	}
	var ret=_.mpq_get_str(null, base, op);
	var ret2=ret.string();
	_.free(ret);
	return ret2;
}

gmp.f=function (value, base) {
	var ret=_.New(_.mpf_t);
	_.mpf_init(ret);

	if (value===undefined) {
		return ret;
	}

	if (base==undefined) base=0;

	switch(typeof(value)) {
	case "string":
		var res=_.mpf_set_str(ret, value, base);
		if (res==-1) {
			gmp.f.clear(ret);
			throw("gmp.q");
		}
		break;
	case "number":
		_.mpf_set_d(ret, value);
		break;
	case "object": // assume it's a gmp.z
		_.mpf_set(ret, value);
		break;
	}
	return ret;
}

gmp.f.get_str=function(op, n_digits, base) {
	if (base==undefined) {
		base=10;
	}
	var exp=[0];
	var ret=_.mpf_get_str(null, exp, base, n_digits, op);
	var ret2=ret.string();
	_.free(ret);
	return [ret2, exp[0]];
}

