html={};

/*
toXML(file, [URL], [encoding], [options]) => XML

Reads an HTML file, tidies up hanging tags etc and returns an XML object.

''file'' can be a file object or a string. File objects only need
to implement the read and close methods. If the file object contains
a regular file, the file descriptor is accessed directly, bypassing
the read and close methods. If it is a stringfile, the string is
accessed directly.
*/

html.toXML=function(file, URL, encoding, options) {
	var xml=libxml2.parseHTML(file, URL, encoding, options).toString();
	xml=xml.substr(xml.indexOf("\n")+1);
	return new XML(xml);
}

html.encode=function(str) {
	str=str.replace(/</g,"&lt;");
	str=str.replace(/>/g,"&gt;");
	return str;
}
