http={};

http.decode=function(qry) {
	if (qry==undefined) return;
	return decodeURIComponent(qry.replace(/\+/g," "));
}

http.encode=encodeURIComponent;

/*
====decode_uri_qry(qry)====

qry should be the part of an url to the right of the question mark, i.e.

foo=a&bar=b

Will return an object containing the properties foo="a" and bar="b".

*/

http.decode_qry=function(qry) {
	if (qry==undefined) return;
	var get={};
	var vars=qry.split("&");
	var i;
	for (i in vars) {
		var pair=vars[i].split("=");
		get[pair[0]]=this.decode(pair[1]);
	}
	return get;
}

http.decode_uri=function(uri) {
	//                   proto         user      passwd       host      port        path           qry           section
	var parts=uri.match(/([^:]+):\/\/((([^:@]+)(:([^@]+))?@)?(([^:\/]*)(:([0-9]+))?)(\/[^\?]*))?(\?([^#]*))?(#(.*))?/);
	if (parts==null) {
		var ret={
			protocol:"file",
			path:uri
		}
	} else {
		var ret={
			protocol:parts[1],
			username:parts[4],
			password:parts[6],
			host:parts[8],
			port:parts[10],
			path:parts[11],
			qry:this.decode_qry(parts[13]),
			section:this.decode(parts[15])
		}
	}
	return ret;
}

/*
====encode_uri(qry)====

does the precise opposite of decode_uri
*/

http.encode_uri=function(obj) {
	var ret="";
	if (obj.protocol!=undefined) ret+=obj.protocol+"://";
	if (obj.username!=undefined) ret+=obj.username;
	if (obj.password!=undefined) ret+=":"+obj.password;
	if (obj.username!=undefined || obj.password!=undefined) ret+="@";
	if (obj.host!=undefined) ret+=obj.host;
	if (obj.port!=undefined) ret+=":"+obj.port;
	if (obj.path!=undefined) ret+=obj.path;
	if (obj.qry!=undefined) ret+="?"+this.encode_qry(obj.qry);
	if (obj.section!=undefined) ret+="#"+this.encode(obj.section);
	return ret;
}

http.encode_qry=function(obj) {
	if (obj==undefined) return;
	var ret=[];
	var i;
	for (i in obj) ret.push(i+"="+this.encode(obj[i]));
	return ret.join("&");
}

/*
====add_headers(file)====

Adds headers to file object. After this function is called, it is possible to add headers to the file
like this:

 file.headers['Content-type']='image/gif';

By default, only one header is set: Content-type: text/html.
The first time file.write is called (directly or indirectly through file.writelines), the headers
are encoded, sent and deleted from the file object. Modifying headers after that raises an error.

Headers may be strings, like in the example above, or string objects. If the string object has
properties, they are encoded as header attributes.

*/

http.add_headers=function(file) {
	file._write=file.write;
	file.write=http.write_headers;
	file.headers={'Content-type':'text/html'};
	file.headers_sent=false;
}

/**/

http.write_headers=function(str) {
	this.write=this._write;
	http.send_headers(this);
	delete this.headers;
	return this.write(str);
}

/**/

http.send_headers=function(file) {
	var i;
	for (i in file.headers) {
		file.write(i+": "+mime.name_value_pair_encode(file.headers[i]));
		file.write("\r\n");
	}
	file.write("\r\n");
}

/**/

http.get=function(url) {
	
}