module=function(){};

module.operation=function (step) {
	return Inner;

	function Inner(module, nothrow) {
	try {
		var full_filename;
		var only_filename;
		var path;
		var olddir=undefined;

		if (module==undefined) { // work on cwd
		} else if (module.indexOf(os.sep)!=-1) { // path given
			var pos=module.lastIndexOf(os.sep);
			path=module.substr(0,pos);
			if (_.chdir(path)) {
				throw("include: Bad path '"+path+"'");
			}
			var only_filename=module.substr(pos+1);
			full_filename=module;
		} else { // search path
			full_filename=global.module.resolve(module);
			if (full_filename==undefined) {
				throw('include: Could not find '+module+
					' in search path '+include_path.join(os.pathsep));
			}

			var lastslash=full_filename.lastIndexOf(os.sep);
			if (lastslash!=-1) {
				path=full_filename.substr(0,lastslash);
				var only_filename=full_filename.substr(lastslash+1);
			} else {
				var only_filename=full_filename;
				path="";
			}
		}

		// only_filename only contains anything after last slash
		// path contains absolute path
		// full_filename contains absolute path and only_filename
		// All these are undefined in no module name is given

		if (module!=undefined) {
			// Save old working directory

			if (_.fchdir)
				olddir=_.open(".",_.O_RDONLY);
			else
				olddir=os.getcwd();

			// Switch to new working directory

			if (_.chdir(path)) {
				throw('module.'+step+': Can\'t chdir to '+path);
			}
		}

		nothrow=false;

		if (module==undefined || only_filename=="") {
			// operating on a directory
			if (os.exists("_"+step+".js")) load("_"+step+".js");
			else if (!global.module.already[step][module]) {
				global.module.already[step][module]=true; // prevent double inclusion
				global.module["auto"+step]();
			}
		} else if (!global.module.already[step][module]) {
			// operating on a file
			global.module.already[step][module]=true; // prevent double inclusion
			if (step=="include") {
				if (only_filename.substr(only_filename.length-3)==".js")
					load(only_filename);
				else if (only_filename.substr(only_filename.length-os.dlext.length)==os.dlext)
					dl.call(_,os.curdir+os.sep+only_filename);
			}
		}

		return true;

	} catch (err) {

		delete global.module.already[step][module]; // step failed, retry next time
		if (nothrow) return false;
		else throw(err);

	} finally {

		if (olddir!=undefined) {
			if (_.fchdir) {
				_.fchdir(olddir);
				_.close(olddir);
			} else {
				_.chdir(olddir);
			}
		}

	}
	}
}

module.already=[];
for each (var step in ["build", "test", "install", "include", "clean"]) {
	module[step]=module.operation(step);
	module.already[step]=[];
}

module.autobuild=function() {
	for each (var filename in dir()) {
		if (filename.match(/\.c$/)) {
			var outfilename=filename.substr(0,filename.length-2)+os.dlext;
			var lastbuild=os.stat(outfilename);
			if (lastbuild) lastbuild=lastbuild.mtime;
			if (os.stat(filename).mtime > lastbuild) {
				print("Compiling ",filename,"\n");
				C.compilefile(filename,outfilename);
			}
		}
	}
	for each (var filename in dir()) {
		if (filename.match(/\.h$/)) {
			var lastbuild=os.stat(filename+os.dlext);
			if (lastbuild) lastbuild=lastbuild.mtime;
			if (os.stat(filename).mtime > lastbuild) {
				print("Building wrapper for ",filename,"\n");
				var dlname=os.curdir+os.sep+filename.replace(/\.h$/,os.dlext);
				var default_dl=undefined;
				if (os.exists(dlname)) default_dl=dl(dlname);
				var wrapper=C.C_wrapper(read(filename),default_dl);
				write(filename+'.cdbg',wrapper);
				C.compilefile(filename+'.cdbg',filename+os.dlext);
			}
		}
	}
}

/*
===module.autoinstall()===

Installs module in cwd into installation directory. Copies all .so, .dll and .js
files except those beginning with _ or ., except _include.js.

Removes any previous module in installation directory by same name

*/

module.autoinstall=function() {
	if (os.exists("_build.js")) load("_build.js");
	else this.build();

	// Find directory name
	var name=os.getcwd().match("\\"+os.sep+"([^\\"+os.sep+"]*)$")[1];

	var dest_dir=install_dir+os.sep+name;

	if (dest_dir==os.getcwd()) throw("Do not install from installation directory");

	if (!os.access(install_dir, os.W_OK)) throw("No write access to "+install_dir);



	if (os.exists(dest_dir)) {
		// Purge old module by same name
		os.deltree(dest_dir);
	}

	os.makedirs(dest_dir);
//	os.system("install -d \""+dest_dir+"\"");


	for each (var filename in dir()) {
		if (filename.match("\.js$|"+os.dlext+"$") &&
			filename[0]!='.' && (filename[0]!='_' || filename=='_include.js')) {
			if (global._WIN32)
				os.system("copy /b \""+filename+"\" \""+dest_dir+"\"");
			else
				os.system("install -m 644 \""+filename+"\" \""+dest_dir+"\"");
		}
	}

}

module.autoclean=function() {
	for each (var filename in dir()) {
		if (filename.match(/\.so$|\.a$|\.o$|~$|\.cdbg$|\.dll$|\.lib$|\.obj$|\.exp$|\.pch$/))
			os.unlink(filename);
	}
}

/*
====autoinclude()====

Called by include whenever a direcotry is included which contains no _include.js file.
Links all .so or .dll files in directory, using ''_'' as ''this''.
Loads all .js files in directory except for those beginning with . or _.
*/

module.autoinclude=function() {
	for each (var filename in dir().sort()) {
		if (filename.match("\\.h"+os.dlext+"$") && filename[0]!='.') {
			dl.call(_,os.curdir+os.sep+filename);
		}
	}
	for each (var filename in dir().sort()) {
		if (filename.match(/\.js$/) && filename[0]!='.' && filename[0]!='_') {
			load(filename);
		}
	}
}

module.resolve=function(module) {
	var full_filename;
	var i;
	for (i in include_path) {
		full_filename=include_path[i]+os.sep+module+".js";
		if (_.access(full_filename,_.R_OK)==0) {
			return full_filename;
		}
		full_filename=include_path[i]+os.sep+module+os.dlext;
		if (_.access(full_filename,_.R_OK)==0) {
			return full_filename;
		}
		full_filename=include_path[i]+os.sep+module+os.sep;
		if (_.access(full_filename,_.R_OK)==0) {
			return full_filename;
		}
	}
}

module.autotest=function() {
}
