/*
  RegisterClass(Object Options, [Object DefaultOptions, [Object Flags]])
   -> new Window Class having DefaultOptions, Flags

*/ 

var RegisterClass=function(ClassName, Options, DefaultOptions, Flags) {
	this.Options=Options=windows.MergeOptions(Options, {
	    Background: _.COLOR_BACKGROUND+1,
	    Icon: _.LoadIcon(_.JSEXT_get_hInstance(), 4),
	    Cursor: _.LoadCursor(_.JSEXT_get_hInstance(), _.IDC_ARROW),
		IconSm: null,
	    SAVEBITS: true
	}, {style: windows.Flags.CS});

	if (ClassName==undefined) {
		throw("RegisterClass: missing ClassName");
	}

	if (DefaultOptions==undefined) DefaultOptions={};

	var NewClass=windows.Window.Constructor(DefaultOptions, Flags);
	NewClass.prototype=new windows.Window;

	var Atom=_.RegisterClassEx({
		cbSize: _.sizeof(_.WNDCLASSEX),
		Style: Options.style,
		lpfnWndProc: windows.MsgHandler.CallbackPointer,
		hInstance: _.JSEXT_get_hInstance(),
		hIcon: Options.Icon,
		hCursor: Options.Cursor,
		hbrBackground: Options.Background,
		lpszClassName: ClassName,
	    lpszMenuName: null,
		hIconSm: Options.IconSm
	});
		
	if (!Atom) {
		throw("RegisterClass '"+ClassName+"': "+windows.ErrorMessage());
	}

	NewClass.prototype.ClassName=ClassName;
	NewClass.prototype.Atom=Atom;

	windows.Window.RegisterClass(ClassName);
	return NewClass;
}

RegisterClass.NextID=1;