function ChooseColor(Options) {
	if (Options==undefined)
		Options=windows.ChooseColor.DefaultOptions;
	else
		for (var i in windows.ChooseColor.DefaultOptions)
			if (Options[i]==undefined)
				Options[i]=windows.ChooseColor.DefaultOptions[i];

	var Flags=0;

	for (var flag in Options)
		if (Options[flag]==true) {
		    if (_["CC_"+flag.toUpperCase()]!=undefined)
			    Flags |= _["CC_"+flag.toUpperCase()];
	    }
	var cc={
		lStructSize: _.sizeof(_.CHOOSECOLOR),
		lpCustColors: Options.CustColors,
		Flags: Flags
	};

	if (_.ChooseColor(cc)) return cc.rgbResult;
}

ChooseColor.DefaultOptions={
	CustColors:[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
}

windows.LogFontDefaults={
		Height: 0,
		Width: 0,
		Escapement: 0,
		Orientation: 0,
		Weight: "DONTCARE",
		Italic: false,
		Underline: false,
		StrikeOut: false,
		CharSet: "DEFAULT",
		OutPrecision: "DEFAULT",
		ClipPrecision: "DEFAULT_PRECIS",
		Quality: "DEFAULT",
		Pitch: "DEFAULT",
		Family: "DONTCARE",
		FaceName: ""
}

windows.LogFontSets={
		Weight: Flags.FW,
		CharSet: Flags.CHARSET,
		OutPrecision: Flags.OUT_PRECIS,
		ClipPrecision: Flags.CLIP,
		Quality: Flags.QUALITY,
		Pitch: Flags.PITCH,
		Family: Flags.FF
}

function ParseLogFont(lf) {
		var ret={};
		for (var i in lf) ret[i.substr(2)]=lf[i];
		ret.Pitch=ret.PitchAndFamily & 0x0f;
		ret.Family=ret.PitchAndFamily & 0xf0;
		delete ret.PitchAndFamily;
		ret=windows.MapSets(ret, windows.LogFontSets);
		var FaceNameLen=ret.FaceName.indexOf("\0");
		if (FaceNameLen>=0)	ret.FaceName=ret.FaceName.substr(0,FaceNameLen);
		return ret;
}

function CreateLogFont(Options) {
	Options=windows.MergeOptions(Options, windows.LogFontDefaults, undefined, windows.LogFontSets);

	Options.PitchAndFamily=Options.Pitch | Options.Family;
	delete Options.Pitch;
	delete Options.Family;

	var lf={};
	for (var i in Options)
		lf["lf"+i]=Options[i];
	return lf;
}

function CreateFont(Options) {
	var lf=windows.CreateLogFont(Options);
	var ret=_.CreateFontIndirect(lf);
	if (ret!=null) return ret;
}

function ChooseFont(Options) {
	var lf=windows.CreateLogFont(Options);

	Options=windows.MergeOptions(Options, {
		Owner: null,
		INITTOLOGFONTSTRUCT: true,
		SCREENFONTS: true
	}, {Flags: windows.Flags.CF});

	if (Options.Owner) Options.Owner=Options.Owner.Wnd;

	var cf={
		lStructSize: _.sizeof(_.CHOOSEFONT),
		hwndOwner: Options.Owner,
		lpszStyle: Pointer(1024),
		Flags: Options.Flags,
		lpLogFont: lf
	};

	if (_.ChooseFont(cf)) {
		return windows.ParseLogFont(cf.lpLogFont);
	}
}

function LoadImage(Name, Options) {
	Options=windows.MergeOptions(Options, {
		LOADFROMFILE: true,
		DEFAULTSIZE: true,
		LOADFROMFILE: true,
		inst: null,
		Type: _.IMAGE_BITMAP,
		xDesired: 0,
		yDesired: 0
	}, {Load: windows.Flags.LR});

	var ret=_.LoadImage(
		Options.inst,
		Name,
		Options.Type,
		Options.xDesired,
		Options.yDesired,
		Options.Load);

	if (ret==null) throw("LoadImage: "+windows.ErrorMessage());
	return ret;
}

for each (var i in ["OBM", "OIC", "OCR"])
	LoadImage[i]=function(Name, Options) {
		Options=windows.MergeOptions(Options, {
			LOADFROMFILE: false,
			SHARED: true
		});
		
		return windows.LoadImage(windows.Flags[i][Name], Options);
	}

function GetOpenFileName(Options) {
	Options=windows.MergeOptions(Options, {
		Owner: null,
		Title: null
	}, {Flags: windows.Flags.OFN});

	var ofn={
		lStructSize: _.sizeof(_.OPENFILENAME),
	    lpstrFile: Pointer(1024),
		nMaxFile: 1024/windows.CharSize,
	    lpstrTitle: Options.Title,
		Flags: Options.Flags
	}
	_.memcpy(ofn.lpstrFile,[0],4);
	_.GetOpenFileName(ofn);
	ofn.File=windows.Str.call(ofn.lpstrFile);
	return ofn;
}