var Windows={};

/*
  Window class
*/ 

var Window=function(Options) {
	if (arguments.length==0) return;

	Options=windows.MergeOptions(Options, {
		WindowName: "",
		x: _.CW_USEDEFAULT,
		y: _.CW_USEDEFAULT,
		Width: _.CW_USEDEFAULT,
		Height: _.CW_USEDEFAULT,
		VISIBLE: true,
		NOTIFY: true,
	}, {
		Style: windows.Flags.WS,
		ExStyle: windows.Flags.WS_EX
	});

	if (Options.Parent) {
		this.Parent=Options.Parent;
		var menu=null;
		Options.Style |= _.WS_CHILD;
	} else if (Options.Menu) {
		this.Menu=new windows.Menu(Options.Menu);
		var menu=this.Menu.Menu;
	} else {
		menu=null;
	}

	this.Wnd=_.CreateWindowEx(
		Options.ExStyle,
		this.ClassName,
		Options.WindowName,
		Options.Style,
		Options.x,
        Options.y,
        Options.Width,
        Options.Height,
        Options.Parent!=undefined?Options.Parent.Wnd:null,
        menu,
        _.JSEXT_get_hInstance(),
        null);

	if (!this.Wnd) {
		throw("windows::Window: "+windows.ErrorMessage());
	}

	this.Options=Options;

	windows.Windows[Number(this.Wnd)]=this;
	windows.EvtHandler.call(this); // parent constructor
}

Window.prototype=new EvtHandler;
Window.prototype.EvtHandlers=[];

Window.Constructor=function(DefaultOptions, Flags) {
    return inner;

    function inner(Options) {
		if ("initfunc" in arguments.callee) {
			arguments.callee.initfunc();
			delete arguments.callee.initfunc();
		}
		Options=windows.MergeOptions(Options, DefaultOptions, Flags);
        windows.Window.call(this, Options); // parent constructor
    }
}

Window.RegisterClass=function(name) {
	this.prototype["New"+name]=inner;

    function inner(Options) {
		if (!Options) Options={};
		Options.Parent=this;
        return new windows[name](Options);
    }
}

// Window functions

Window.prototype.Show=function(CmdShow) {
	if (CmdShow==undefined) CmdShow=_.JSEXT_get_nCmdShow();
    _.ShowWindow(this.Wnd, CmdShow);
}

Window.prototype.Update=function() {
    _.UpdateWindow(this.Wnd);
}

/*

Window Functions
The following functions are used to create and manage windows. 

  
 
"WS"
"WS_EX"
_.AdjustWindowRectEx(this.Wnd, rect,
	style, Options.menu, exstyle);
"AW"
_.AnimateWindow(this.Wnd, time, flags);
_.ArrangeIconicWindows(this.Wnd);
_.BringWindowToTop(this.Wnd);
"MDITILE"
kidshwnd=[];
for each (var wnd in kids)
	kidshwnd.push(wnd.hwnd);
if (rect==undefined) rect=null;
_.CascadeWindows(this.Wnd, how, rect, kids.length, kidshwnd)
"CWP"
ChildWindowFromPointEx(this.Wnd, point, flags);
CloseWindow(this.Wnd);
BeginDeferWindowPos
DeferWindowPos
EndDeferWindowPos  
DestroyWindow(this.Wnd)
if (enable==undefined) enable=true;
EnableWindow(this.Wnd, enable)
//EnumChildProc
var penum=Pointer(windows.Window.enumcallback, this.App);
EnumChildWindows(this.Wnd, penum, 0)
//EnumThreadWndProc  
EnumThreadWindows(threadid, penum, 0)
//EnumWindowsProc  
EnumWindows(penum, 0);
FindWindowEx(this.Wnd, ChildAfter?ChildAfter.hwnd:null, ClassName, Caption?Caption:null);
var rect={};
GetClientRect(this.Wnd, rect);
return rect;
var hwnd=GetDesktopWindow();
return new Window(hwnd);
var hwnd=GetForegroundWindow()
if (App...) return App...
return new Window(hwnd);
var hwnd=GetLastActivePopup(this.Wnd);
if (App...) return App...
return new Window(hwnd);

GetParent // in constructor from hwnd

GetTopWindow(this.Wnd);

"GW"
GetWindow(this.Wnd, cmd)

wndpl={};
GetWindowPlacement(this.Wnd, wndpl);
"WPF"
"SW"
return wndpl;

var rect={};
GetWindowRect(this.Wnd, rect)
return rect;

var len=GetWindowTextLength(this.Wnd);
buf=Pointer((len+1)*windows.CharSize);
GetWindowText(this.Wnd, buf, len+1)
return windows.Str.call(buf);

var proc_id=[0];
var thread_id=GetWindowThreadProcessId(this.Wnd, procid);
return [thread_id, proc_id[0]];

return IsChild(this.Wnd, window.hwnd)?true:false;

return IsIconic(this.Wnd)?true:false;
return _.IsWindow(this.Wnd)?true:false;
return _.IsWindowUnicode(this.Wnd)?true:false;
return _.IsWindowVisible(this.Wnd)?true:false;
return _.IsZoomed(this.Wnd)?true:false;
if (!MoveWindow(this.Wnd,x,y,width,height,repaint))
	error
(!_.OpenIcon(this.Wnd))
	error
return _.SetForegroundWindow(this.Wnd)?true:false;

if (!_.SetParent(this.Wnd, window.hwnd)) {
	error
} else {
// +++
}

"GWL","DWL"
SetWindowLong(this.Wnd, index, value);
// -> setoptions

"WPF", "SW"
SetWindowPlacement(this.Wnd, {length:_.sizeof(_.WINDOWPLACEMENT), flags, showCmd, });

SetWindowPos  
SetWindowText  
ShowOwnedPopups  
ShowWindow  
ShowWindowAsync  
TileWindows  
WindowFromPoint  
WinMain  


*/ 

// Messages to windows

Window.prototype.SETTEXT=function(str) {
	x=_.StrDup(str); // Need to make a copy because of
					// type mismatch. The lParam parameter
					// in SendMessage is declared as an int,
					// and a string will not convert correctly
					// to an int. A pointer, on the other hand,
					// will.
	var ret=_.SendMessage(this.Wnd, _.WM_SETTEXT,0, x);
	_.LocalFree(x);
	return ret!=0;
}

Window.prototype.GETTEXT=function() {
	var len=this.gettextlength();
	var buf=new Pointer((len+1)*windows.CharSize);
	_.SendMessage(this.Wnd, _.WM_GETTEXT,len+1, buf);
	return windows.Str.call(buf);
}

Window.DefaultMethod=function(msg) {
	return Inner;

	function Inner(wParam, lParam) {
		return _.SendMessage(this.Wnd, msg, wParam?wParam:0, lParam?lParam:0);
	}
}

for (var i in Flags.WM) {
	if (Window.prototype[i]==undefined)
		Window.prototype[i]=Window.DefaultMethod(Flags.WM[i]);
}
